- Home
- Cyrus IMAP
- Download
- Contribute

# sasl_getrealm_t - Realm Acquisition Callback

## Synopsis

    #include <sasl/sasl.h>

    int sasl_getrealm_t(void *context,
        int id,
        const char **availrealms,
        const char **result)

## Description

`int sasl_getrealm_t(void *context,`
`int id,`
`const char **availrealms,`
`const char **result)`

  sasl_getrealm_t() is used when there is an interaction with SASL_CB_GETREALM as the type.

  If a mechanism would use this callback, but it is not present, then the first realm listed is automatically selected. (Note that a mechanism may still force the existence of a getrealm callback by SASL_CB_GETREALM to its required_prompts list).

  Parameters:

  - context – context from the callback record
  - id – callback ID (SASL_CB_GETREALM)
  - availrealms – A string list of the available realms. NULL terminated, may be empty.
  - result – The chosen realm. (a NUL terminated string)

## Return Value

SASL callback functions should return SASL return codes. See sasl.h for a complete list. `SASL_OK` indicates success.

Other return codes indicate errors and should be handled.

## See Also

RFC 4422,:saslman:sasl(3), sasl_callbacks(3)